diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java
index d23ba5ffc0..bbb72bb378 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java
@@ -14,7 +14,9 @@ import static org.junit.Assert.assertNotNull;
 
 import java.io.FileNotFoundException;
 import java.io.IOException;
+import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.EnumSet;
 import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
@@ -22,6 +24,7 @@ import java.util.Set;
 import java.util.UUID;
 
 import org.apache.commons.lang.RandomStringUtils;
+import org.apache.log4j.Level;
 import org.apache.log4j.Logger;
 import org.apache.lucene.document.Document;
 import org.apache.lucene.index.CorruptIndexException;
@@ -37,21 +40,29 @@ import eu.etaxonomy.cdm.api.service.config.FindTaxaAndNamesConfiguratorImpl;
 import eu.etaxonomy.cdm.api.service.config.IFindTaxaAndNamesConfigurator;
 import eu.etaxonomy.cdm.api.service.pager.Pager;
 import eu.etaxonomy.cdm.api.service.search.ICdmMassIndexer;
+import eu.etaxonomy.cdm.api.service.search.LuceneMultiSearchException;
 import eu.etaxonomy.cdm.api.service.search.SearchResult;
+import eu.etaxonomy.cdm.common.UTF8;
 import eu.etaxonomy.cdm.common.monitor.DefaultProgressMonitor;
 import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
+import eu.etaxonomy.cdm.model.common.CdmBase;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.description.AbsenceTerm;
 import eu.etaxonomy.cdm.model.description.CategoricalData;
 import eu.etaxonomy.cdm.model.description.CommonTaxonName;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
+import eu.etaxonomy.cdm.model.description.PresenceTerm;
 import eu.etaxonomy.cdm.model.description.State;
 import eu.etaxonomy.cdm.model.description.StateData;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.description.TextData;
+import eu.etaxonomy.cdm.model.location.Country;
+import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.NonViralName;
 import eu.etaxonomy.cdm.model.name.Rank;
@@ -64,6 +75,8 @@ import eu.etaxonomy.cdm.model.taxon.SynonymRelationshipType;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.model.taxon.TaxonNode;
+import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;
+import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
 import eu.etaxonomy.cdm.persistence.query.MatchMode;
 import eu.etaxonomy.cdm.test.integration.CdmTransactionalIntegrationTest;
 import eu.etaxonomy.cdm.test.unitils.CleanSweepInsertLoadStrategy;
@@ -72,7 +85,6 @@ import eu.etaxonomy.cdm.test.unitils.CleanSweepInsertLoadStrategy;
 /**
  * @author a.babadshanjan, a.kohlbecker
  * @created 04.02.2009
- * @version 1.0
  */
 public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
@@ -90,6 +102,8 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
     private static Logger logger = Logger.getLogger(TaxonServiceSearchTest.class);
 
+
+
     @SpringBeanByType
     private ITaxonService taxonService;
     @SpringBeanByType
@@ -107,15 +121,30 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
     private static final int BENCHMARK_ROUNDS = 300;
 
-	/**
-	 * @throws java.lang.Exception
-	 */
-	@Before
-	public void setUp() throws Exception {
-		indexer.clearIndexedClasses();
-    	indexer.addToIndexedClasses(DescriptionElementBase.class);
-		indexer.addToIndexedClasses(TaxonBase.class);
-	}
+    private Set<Class<? extends CdmBase>> typesToIndex = null;
+
+    private NamedArea germany;
+    private NamedArea france ;
+    private NamedArea russia ;
+    private NamedArea canada ;
+
+    /**
+     * @throws java.lang.Exception
+     */
+    @Before
+    public void setUp() throws Exception {
+        typesToIndex = new HashSet<Class<? extends CdmBase>>();
+        typesToIndex.add(DescriptionElementBase.class);
+        typesToIndex.add(TaxonBase.class);
+        typesToIndex.add(TaxonRelationship.class);
+
+        germany =  Country.GERMANY();
+        france = Country.FRANCEFRENCHREPUBLIC();
+        russia = Country.RUSSIANFEDERATION();
+        canada = Country.CANADA();
+
+    }
+
     @Test
     public void testDbUnitUsageTest() throws Exception {
         assertNotNull("taxonService should exist", taxonService);
@@ -159,7 +188,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         }
 
         logger.debug("number of taxa: " + list.size());
-        assertEquals(7, list.size());
+        assertEquals(8, list.size());
 
         // pass 2
 //        configurator.setDoTaxaByCommonNames(false);
@@ -192,7 +221,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         Pager<SearchResult<TaxonBase>> pager;
 
         pager = taxonService.findByFullText(null, "Abies", null, null, true, null, null, null, null); // --> 7
-        Assert.assertEquals("Expecting 7 entities", Integer.valueOf(7), pager.getCount());
+        Assert.assertEquals("Expecting 8 entities", Integer.valueOf(8), pager.getCount());
 
         indexer.purge(null);
         commitAndStartNewTransaction(null);
@@ -211,7 +240,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         Pager<SearchResult<TaxonBase>> pager;
 
-        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Weißtanne", null, null, null,
+        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Wei"+UTF8.SHARP_S+"tanne", null, null, null,
                 false, null, null, null, null);
         Assert.assertEquals("Expecting one entity when searching for CommonTaxonName", Integer.valueOf(1),
                 pager.getCount());
@@ -222,11 +251,11 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
                 false, null, null, null, null);
         Assert.assertEquals("Expecting no entity when searching for 'Nulltanne' ", Integer.valueOf(0), pager.getCount());
 
-        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Weißtanne", null, null,
+        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Wei"+UTF8.SHARP_S+"tanne", null, null,
                 Arrays.asList(new Language[] { Language.GERMAN() }), false, null, null, null, null);
         Assert.assertEquals("Expecting one entity when searching in German", Integer.valueOf(1), pager.getCount());
 
-        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Weißtanne", null, null,
+        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Wei"+UTF8.SHARP_S+"tanne", null, null,
                 Arrays.asList(new Language[] { Language.RUSSIAN() }), false, null, null, null, null);
         Assert.assertEquals("Expecting no entity when searching in Russian", Integer.valueOf(0), pager.getCount());
 
@@ -241,8 +270,8 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         Pager<SearchResult<TaxonBase>> pager;
         // by Area
-        pager = taxonService.findByDescriptionElementFullText(null, "America", null, null, null, false, null, null, null, null);
-        Assert.assertEquals("Expecting one entity when searching for arae 'America'", Integer.valueOf(1), pager.getCount());
+        pager = taxonService.findByDescriptionElementFullText(null, "Canada", null, null, null, false, null, null, null, null);
+        Assert.assertEquals("Expecting one entity when searching for arae 'Canada'", Integer.valueOf(1), pager.getCount());
         // by Status
         pager = taxonService.findByDescriptionElementFullText(null, "present", null, null, null, false, null, null, null, null);
         Assert.assertEquals("Expecting one entity when searching for status 'present'", Integer.valueOf(1), pager.getCount());
@@ -257,7 +286,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         Pager<SearchResult<TaxonBase>> pager;
 
-        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Weiß*", null, null, null, false, null, null, null, null);
+        pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Wei"+UTF8.SHARP_S+"*", null, null, null, false, null, null, null, null);
         Assert.assertEquals("Expecting one entity when searching for CommonTaxonName", Integer.valueOf(1), pager.getCount());
     }
 
@@ -438,10 +467,11 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
      * @throws CorruptIndexException
      * @throws IOException
      * @throws ParseException
+     * @throws LuceneMultiSearchException
      */
     @Test
     @DataSet
-    public final void testFullText_Grouping() throws CorruptIndexException, IOException, ParseException {
+    public final void testFullText_Grouping() throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException {
 
         TaxonDescription description = (TaxonDescription) descriptionService.find(UUID.fromString(D_ABIES_ALBA_UUID));
         Set<String> uniqueRandomStrs = new HashSet<String>(1024);
@@ -461,15 +491,28 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         int pageSize = 10;
 
         Pager<SearchResult<TaxonBase>> pager;
-
         boolean highlightFragments = true;
+
+        // test with findByDescriptionElementFullText
         pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Rot*", null, null, null, highlightFragments, pageSize, null, null, null);
-        Assert.assertEquals("All matches should be grouped in one page", 1, pager.getPagesAvailable().intValue());
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("All matches should be grouped into a single SearchResult element", 1, pager.getRecords().size());
+        Assert.assertEquals("The count property of the pager must be set correctly", 1, pager.getCount().intValue());
         Map<String, String[]> highlightMap = pager.getRecords().get(0).getFieldHighlightMap();
         // maxDocsPerGroup is defined in LuceneSearch and defaults to 10
         int maxDocsPerGroup = 10;
         Assert.assertEquals("expecting 10 highlighted fragments of field 'name'", maxDocsPerGroup, highlightMap.get("name").length);
 
+        // test with findByEverythingFullText
+        pager = taxonService.findByEverythingFullText( "Rot*", null, null, highlightFragments, pageSize, null, null, null);
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("All matches should be grouped into a single SearchResult element", 1, pager.getRecords().size());
+        Assert.assertEquals("The count property of the pager must be set correctly", 1, pager.getCount().intValue());
+        highlightMap = pager.getRecords().get(0).getFieldHighlightMap();
+        // maxDocsPerGroup is defined in LuceneSearch and defaults to 10
+        maxDocsPerGroup = 10;
+        Assert.assertEquals("expecting 10 highlighted fragments of field 'name'", maxDocsPerGroup, highlightMap.get("name").length);
+
     }
 
     @SuppressWarnings("rawtypes")
@@ -481,10 +524,11 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         Pager<SearchResult<TaxonBase>> pager;
         pager = taxonService.findByDescriptionElementFullText(TextData.class, "Abies", null, null, null, false, null, null, null, null);
+        logPagerRecords(pager, Level.DEBUG);
         Assert.assertEquals("Expecting one entity when searching for any TextData", Integer.valueOf(1), pager.getCount());
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getEntity().getTitleCache());
-        Assert.assertTrue("Expecting only one doc", pager.getRecords().get(0).getDocs().size() == 1);
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getDocs().iterator().next().get("inDescription.taxon.titleCache"));
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getEntity().getTitleCache());
+        Assert.assertTrue("Expecting two docs, one for RUSSIAN and one for GERMAN", pager.getRecords().get(0).getDocs().size() == 2);
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getDocs().iterator().next().get("inDescription.taxon.titleCache"));
 
 
         pager = taxonService.findByDescriptionElementFullText(null, "Abies", null, null, null, false, null, null, null, null);
@@ -504,18 +548,18 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         pager = taxonService.findByDescriptionElementFullText(TextData.class, "Бальзам", null, null, Arrays.asList(new Language[]{}), false, null, null, null, null);
         Assert.assertEquals("Expecting one entity", Integer.valueOf(1), pager.getCount());
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getEntity().getTitleCache());
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getEntity().getTitleCache());
 
         pager = taxonService.findByDescriptionElementFullText(TextData.class, "Бальзам", null, null, Arrays.asList(new Language[]{Language.RUSSIAN()}), false, null, null, null, null);
         Assert.assertEquals("Expecting one entity", Integer.valueOf(1), pager.getCount());
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getEntity().getTitleCache());
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getEntity().getTitleCache());
 
         pager = taxonService.findByDescriptionElementFullText(TextData.class, "Бальзам", null, null, Arrays.asList(new Language[]{Language.GERMAN()}), false, null, null, null, null);
         Assert.assertEquals("Expecting no entity", Integer.valueOf(0), pager.getCount());
 
         pager = taxonService.findByDescriptionElementFullText(TextData.class, "Balsam-Tanne", null, null, Arrays.asList(new Language[]{Language.GERMAN(), Language.RUSSIAN()}), false, null, null, null, null);
         Assert.assertEquals("Expecting one entity", Integer.valueOf(1), pager.getCount());
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getEntity().getTitleCache());
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getEntity().getTitleCache());
     }
 
     @SuppressWarnings("rawtypes")
@@ -633,7 +677,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         d_abies_balsamea_new
                 .addElement(TextData
                         .NewInstance(
-                                "Die Balsamtanne ist mit bis zu 30 m Höhe ein mittelgroßer Baum und kann bis zu 200 Jahre alt werden",
+                                "Die Balsamtanne ist mit bis zu 30 m Höhe ein mittelgro"+UTF8.SHARP_S+"er Baum und kann bis zu 200 Jahre alt werden",
                                 Language.GERMAN(), null));
         t_abies_balsamea.addDescription(d_abies_balsamea_new);
         // set authorshipCache to null to avoid validation exception,
@@ -647,7 +691,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
                 "DESCRIPTIONBASE"
         });
 
-        pager = taxonService.findByDescriptionElementFullText(TextData.class, "mittelgroßer Baum", null, null, Arrays.asList(new Language[]{Language.GERMAN()}), false, null, null, null, null);
+        pager = taxonService.findByDescriptionElementFullText(TextData.class, "mittelgro"+UTF8.SHARP_S+"er Baum", null, null, Arrays.asList(new Language[]{Language.GERMAN()}), false, null, null, null, null);
         Assert.assertEquals("the taxon should be found via the new Description", Integer.valueOf(1), pager.getCount());
     }
 
@@ -678,7 +722,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         Assert.assertEquals("expecting default classification", childNode.getClassification().getUuid().toString(), CLASSIFICATION_UUID);
 
         // moving the taxon around
-        alternateClassification.addChildNode(childNode, null, null, null);
+        alternateClassification.addChildNode(childNode, null, null);
         classificationService.saveOrUpdate(alternateClassification);
         commitAndStartNewTransaction(null);
 
@@ -712,7 +756,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         StateData statedata = StateData.NewInstance(state);
         statedata.putModifyingText(Language.ENGLISH(), "always, even during winter");
-        cdata.addState(statedata);
+        cdata.addStateData(statedata);
         d_abies_balsamea.addElement(cdata);
 
         termService.save(state);
@@ -728,9 +772,9 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         Pager<SearchResult<TaxonBase>> pager;
         pager = taxonService.findByDescriptionElementFullText(CategoricalData.class, "green", null, null, null, false, null, null, null, null);
         Assert.assertEquals("Expecting one entity", Integer.valueOf(1), pager.getCount());
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getEntity().getTitleCache());
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getEntity().getTitleCache());
         Assert.assertTrue("Expecting only one doc", pager.getRecords().get(0).getDocs().size() == 1);
-        Assert.assertEquals("Abies balsamea sec. ", pager.getRecords().get(0).getDocs().iterator().next().get("inDescription.taxon.titleCache"));
+        Assert.assertEquals("Abies balsamea sec. Kohlbecker, A., Testcase standart views, 2013", pager.getRecords().get(0).getDocs().iterator().next().get("inDescription.taxon.titleCache"));
 
 
         //TODO modify the StateData
@@ -793,19 +837,22 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         refreshLuceneIndex();
 
+        Classification europeanAbiesClassification = classificationService.find(UUID.fromString(CLASSIFICATION_UUID));
+
         Pager<SearchResult<TaxonBase>> pager;
 
         pager = taxonService.findByFullText(null, "Abies", null, null, true, null, null, null, null); // --> 7
-        Assert.assertEquals("Expecting 7 entities", Integer.valueOf(7), pager.getCount());
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("Expecting 8 entities", Integer.valueOf(8), pager.getCount());
 
         pager = taxonService.findByFullText(Taxon.class, "Abies", null, null, true, null, null, null, null); // --> 6
-        Assert.assertEquals("Expecting 6 entities", Integer.valueOf(6), pager.getCount());
+        Assert.assertEquals("Expecting 7 entities", Integer.valueOf(7), pager.getCount());
 
         pager = taxonService.findByFullText(Synonym.class, "Abies", null, null, true, null, null, null, null); // --> 1
         Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), pager.getCount());
 
         pager = taxonService.findByFullText(TaxonBase.class, "sec", null, null, true, null, null, null, null); // --> 7
-        Assert.assertEquals("Expecting 7 entities", Integer.valueOf(7), pager.getCount());
+        Assert.assertEquals("Expecting 8 entities", Integer.valueOf(8), pager.getCount());
 
         pager = taxonService.findByFullText(null, "genus", null, null, true, null, null, null, null); // --> 1
         Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), pager.getCount());
@@ -816,16 +863,163 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         // synonym in classification ???
     }
 
+    @Test
+    @DataSet
+    public final void testPrepareByAreaSearch() throws IOException, ParseException {
+
+        List<PresenceAbsenceTermBase<?>> statusFilter = new ArrayList<PresenceAbsenceTermBase<?>>();
+        List<NamedArea> areaFilter = new ArrayList<NamedArea>();
+        areaFilter.add(germany);
+        areaFilter.add(canada);
+        areaFilter.add(russia);
+
+        Pager<SearchResult<TaxonBase>> pager = taxonService.findByDistribution(areaFilter, statusFilter, null, 20, 0, null, null);
+        Assert.assertEquals("Expecting 2 entities", Integer.valueOf(2), Integer.valueOf(pager.getRecords().size()));
+
+    }
+
+    @Test
+    @DataSet
+    public final void testFindTaxaAndNamesByFullText() throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException {
+
+        refreshLuceneIndex();
+
+        Pager<SearchResult<TaxonBase>> pager;
+
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxa, TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, null, null, null, true, null, null, null, null);
+//        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("Expecting 8 entities", Integer.valueOf(8), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, null, null, null, true, null, null, null, null);
+        Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), pager.getCount());
+
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxaByCommonNames),
+                "Abies", null, null, null, null, true, null, null, null, null);
+        Assert.assertEquals("Expecting 0 entity", Integer.valueOf(0), pager.getCount());
+
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxaByCommonNames),
+                "Tanne", null, null, null, null, true, null, null, null, null);
+        Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), Integer.valueOf(pager.getRecords().size()));
+        Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doMisappliedNames),
+                "kawakamii", null, null, null, null, true, null, null, null, null);
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), pager.getCount());
+
+    }
+
+    @Test
+    @DataSet
+    public final void testFindTaxaAndNamesByFullText_AreaFilter() throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException {
+
+        refreshLuceneIndex();
+
+        Pager<SearchResult<TaxonBase>> pager;
+
+        Set<NamedArea> a_germany_canada_russia = new HashSet<NamedArea>();
+        a_germany_canada_russia.add(germany);
+        a_germany_canada_russia.add(canada);
+        a_germany_canada_russia.add(russia);
+
+        Set<NamedArea> a_russia = new HashSet<NamedArea>();
+        a_russia.add(russia);
+
+        Set<PresenceAbsenceTermBase<?>> present = new HashSet<PresenceAbsenceTermBase<?>>();
+        present.add(PresenceTerm.PRESENT());
+
+        Set<PresenceAbsenceTermBase<?>> present_native = new HashSet<PresenceAbsenceTermBase<?>>();
+        present_native.add(PresenceTerm.PRESENT());
+        present_native.add(PresenceTerm.NATIVE());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxa),
+                "Abies", null, a_germany_canada_russia, null, null, true, null, null, null, null);
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("taxa with matching area filter", Integer.valueOf(2), pager.getCount());
+
+        // abies_kawakamii_sensu_komarov as missapplied name for t_abies_balsamea
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, a_germany_canada_russia, present_native, null, true, null, null, null, null);
+        Assert.assertEquals("synonyms with matching area filter", Integer.valueOf(1), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxa, TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, a_germany_canada_russia, null, null, true, null, null, null, null);
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("taxa and synonyms with matching area filter", Integer.valueOf(3), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxa, TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, a_germany_canada_russia, present_native, null, true, null, null, null, null);
+        Assert.assertEquals("taxa and synonyms with matching area & status filter 1", Integer.valueOf(3), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxa, TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, a_germany_canada_russia, present, null, true, null, null, null, null);
+        Assert.assertEquals("taxa and synonyms with matching area & status filter 2", Integer.valueOf(2), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxa, TaxaAndNamesSearchMode.doSynonyms),
+                "Abies", null, a_russia, present, null, true, null, null, null, null);
+        Assert.assertEquals("taxa and synonyms with non matching area & status filter", Integer.valueOf(0), pager.getCount());
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doTaxaByCommonNames),
+                "Tanne", null, a_germany_canada_russia, present_native, null, true, null, null, null, null);
+        Assert.assertEquals("ByCommonNames with area filter", Integer.valueOf(1), pager.getCount());
+
+        // abies_kawakamii_sensu_komarov as misapplied name for t_abies_balsamea
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doMisappliedNames),
+                "Abies", null, a_germany_canada_russia, present_native, null, true, null, null, null, null);
+        Assert.assertEquals("misappliedNames with matching area & status filter", Integer.valueOf(1), pager.getCount());
+
+        // FIXME #3730 (Taxon.removeTaxonRelation() raises error on update)
+        /* ----------------------------------------------- START
+        // and now also test if updating of the index works properly
+        // 1. remove existing taxon relation
+        Taxon t_abies_balsamea = (Taxon)taxonService.find(UUID.fromString(ABIES_BALSAMEA_UUID));
+        Set<TaxonRelationship> relsTo = t_abies_balsamea.getRelationsToThisTaxon();
+        Assert.assertEquals(Integer.valueOf(1), Integer.valueOf(relsTo.size()));
+        TaxonRelationship taxonRelation = relsTo.iterator().next();
+        t_abies_balsamea.removeTaxonRelation(taxonRelation);
+        taxonService.saveOrUpdate(t_abies_balsamea);
+        commitAndStartNewTransaction(null);
+
+        pager = taxonService.findTaxaAndNamesByFullText(
+                EnumSet.of(TaxaAndNamesSearchMode.doMisappliedNames),
+                "Abies", null, a_germany_canada_russia, present_native, null, true, null, null, null, null);
+        Assert.assertEquals("misappliedNames with matching area & status filter, should match nothing now", Integer.valueOf(0), pager.getCount());
+
+        // 2. now add abies_kawakamii_sensu_komarov as misapplied name for t_abies_alba and search for misapplications in russia: ABSENT
+        // TODO
+        // ---------------------------------------------- END */
+
+    }
+
     /**
      * Regression test for #3119: fulltext search: Entity always null whatever search
      *
      * @throws CorruptIndexException
      * @throws IOException
      * @throws ParseException
+     * @throws LuceneMultiSearchException
      */
     @Test
     @DataSet
-    public final void testFindByEverythingFullText() throws CorruptIndexException, IOException, ParseException {
+    public final void testFindByEverythingFullText() throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException {
 
         refreshLuceneIndex();
 
@@ -833,14 +1027,14 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         // via Taxon
         pager = taxonService.findByEverythingFullText("Abies", null, null, true, null, null, null, null);
+        logPagerRecords(pager, Level.DEBUG);
         Assert.assertTrue("Expecting at least 7 entities for 'Abies'", pager.getCount() > 7);
         Assert.assertNotNull("Expecting entity", pager.getRecords().get(0).getEntity());
         Assert.assertEquals("Expecting Taxon entity", Taxon.class, pager.getRecords().get(0).getEntity().getClass());
 
-        // via DescriptionElement
         // via DescriptionElement
         pager = taxonService.findByEverythingFullText("present", null, null, true, null, null, null, null);
-        Assert.assertEquals("Expecting one entity when searching for arae 'present'", Integer.valueOf(1), pager.getCount());
+        Assert.assertEquals("Expecting one entity when searching for area 'present'", Integer.valueOf(1), pager.getCount());
         Assert.assertNotNull("Expecting entity", pager.getRecords().get(0).getEntity());
         Assert.assertEquals("Expecting Taxon entity", Taxon.class, pager.getRecords().get(0).getEntity().getClass());
         Assert.assertEquals("Expecting Taxon ", ABIES_BALSAMEA_UUID, pager.getRecords().get(0).getEntity().getUuid().toString());
@@ -850,7 +1044,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
     @Test
     @DataSet
-    public final void findByEveryThingFullText() throws CorruptIndexException, IOException, ParseException {
+    public final void findByEveryThingFullText() throws CorruptIndexException, IOException, ParseException, LuceneMultiSearchException {
 
         refreshLuceneIndex();
 
